
include	BigInt.inc


;****************************************************************
;*		R[h						*
;****************************************************************
;---------------------------------------------------------------|
;		1bit Vtg					|
;---------------------------------------------------------------|
;yz							|
;	_Src <<= _Cnt						|
;								|
;	XŁiAA1bit Vtgj			|
;	@@E]vȏ폜				|
;	@@EPɂ				|
;	@@EesiWX^͖gp				|
;								|
;yz							|
;	_Src:		ptr BigInt	VtgIuWFNg	|
;	_Cnt		unsigned int	Vtg		|
;---------------------------------------------------------------|
.code
@BigInt_Shl1@4	proc	syscall	uses	edi
;	_Src:		ptr BigInt,	;(ecx)

	assume	ecx:ptr BigInt

	mov	edx, [ecx].m_sz		;edx = _Src.m_sz
	mov	edi, [ecx].m_pt		;edi = _Src.m_pt

	;rbgPʂ̃Vtg
	mov	ecx, edx
	shr	ecx, 2
	and	edx, 3
	.if	(zero?)
		.if	(ecx != 0)
		  clc
		  .repeat
			rcl	dword ptr [edi], 1
			inc	edi
			inc	edi
			inc	edi
			inc	edi
		  .untilcxz
		.endif
	.else
		.if	(ecx != 0)
		  clc
		  .repeat
			rcl	dword ptr [edi], 1
			inc	edi
			inc	edi
			inc	edi
			inc	edi
		  .untilcxz
		.endif
		mov	ecx, edx
		.repeat
			rcl	byte ptr [edi], 1
			inc	edi
		.untilcxz
	.endif

	ret
@BigInt_Shl1@4	endp
;---------------------------------------------------------------|
;		Vtg					|
;---------------------------------------------------------------|
;yz							|
;	_Src <<= _Cnt						|
;yz							|
;	_Src:		ptr BigInt	VtgIuWFNg	|
;	_Cnt		unsigned int	Vtg		|
;---------------------------------------------------------------|
.code
@BigInt_Shl@8	proc	syscall	uses	ebx edi esi
;	_Src:		ptr BigInt,	;(ecx)
;	_Cnt:		unsigned int	;(edx)

	assume	ecx:ptr BigInt

	mov	esi, [ecx].m_pt		;esi = _Src.m_pt
	mov	eax, [ecx].m_sz		;eax = _Src.m_sz

	mov	ecx, edx
	push	eax
	shr	ecx, 3			;ecx = oCgPʂ̃VtgʁiŁj
	and	edx, 0007h		;edx = rbgPʂ̃Vtgʁi = 0`7 ͈̔́j
	sub	eax, ecx		;eax = rbgVtg钷iŃVtg镪͏Oj

	push	ecx

	lea	edi, [esi + eax - 1]	;edx == 0ׂ̈ɑĂB

	;rbgPʂ̃Vtg
	.while	(edx != 0)
		mov	ecx, eax
		mov	ebx, eax
		shr	ecx, 2
		mov	edi, esi
		and	ebx, 3
		.if	(zero?)
			.if	(ecx != 0)
			  clc
			  .repeat
				rcl	dword ptr [edi], 1
				inc	edi
				inc	edi
				inc	edi
				inc	edi
			  .untilcxz
			.endif
		.else
			.if	(ecx != 0)
			  clc
			  .repeat
				rcl	dword ptr [edi], 1
				inc	edi
				inc	edi
				inc	edi
				inc	edi
			  .untilcxz
			.endif
			mov	ecx, ebx
			.repeat
				rcl	byte ptr [edi], 1
				inc	edi
			.untilcxz
		.endif
		dec	edi
		dec	edx
	.endw

	;Byte(8bit)Pʂ̃Vtg
	pop	eax		;eax = oCgPʂ̃Vtg
	mov	ebx, esi	;ebx = &m_pt[0]
	pop	ecx		;ecx = this.m_sz
	mov	esi, edi	;esi = ]
	sub	ecx, eax	;ecx = ]
	add	edi, eax	;edi = ]iŌj

	;]
	.if	(ecx != 0)
		push	eax
		std			;dec mode
		rep	movsb
		cld			;inc mode
		pop	eax
	.endif

	;]A0x00Ŗ߂B
	.if	(eax != 0)
		mov	ecx, eax
		xor	eax, eax
		mov	edi, ebx
		rep	stosb
	.endif
	
	ret
@BigInt_Shl@8	endp
;****************************************************************
	end
