#include "StdAfx.h"

//==============================================================
//			ZiDivj	񕜖@
//--------------------------------------------------------------
//	
//		BigInt&	_Result	ʁij
//		BigInt&	_Mod	ʁi]j
//		BigInt	_Drc	鐔̃IuWFNgíj
//		BigInt	_Src	鐔̃IuWFNgíj
//	Ԓl
//		bool			true	ok
//						false	0ŏZ
//	
//		񕜖@ɂAƗ]߂܂B
//		_Result	 _Dst  _Src
//		_Mod	 _Dst mod _Src
//==============================================================
bool	BigInt_Div(BigInt* _Result, BigInt* _Mod, BigInt _Dst, BigInt _Src)
{
	//0Z̃`FbN
	if(_Src == 0){
#ifdef	Zero_Div_Err
		//OZ荞݂𔭐iOɂȂG[ɂȂjB
		__asm{	int	0	}
#endif
		return(false);
	}

	char	sign_d	= _Dst.Get_Sign();
	char	sign_s	= _Src.Get_Sign();

	//̐A̐ɂ
	if(sign_d & 0x80){
		_Dst = -_Dst;
	}

	if(sign_s & 0x80){
		_Src = -_Src;
	}

	_Dst.resize();
	_Src.resize();

	//MZ̗v̂ŊZ
	*_Result	= 0;
	if(_Dst.m_sz >= _Src.m_sz){
		//鐔̌̕
		unsigned	int		dt		= (_Dst.m_sz - _Src.m_sz + 1) * 8;
		BigInt				_temp	= 0x01;
		BigInt				_cmp;

		_Src <<= dt;
		_temp <<= dt;
		_Result->resize(_temp.m_sz);		//_Result  _temp 𓯂TCYɂB
		do{
			BigInt_Shr1(&_Src);		//TCY͏ȗB
			BigInt_Shr1(&_temp);	//TCY͏ȗiTCYƁABigInt_OR()֐ŋjB
			_cmp = _Dst - _Src;
			if (!(_cmp.Chk_Sign() & 0x80)){
				BigInt_Or(_Result, &_temp);		//_Result |= _temp; 
				BigInt_Copy(&_Dst, &_cmp);		//__Dst    = _cmp;
			}
			dt--;
		} while(dt > 0);
	}

	_Result->resize();		//TCY

	//鐔A鐔̂ǂ炩Aʂ𕉐ցB
	if((sign_d ^ sign_s) & 0x80){
		*_Result = -*_Result;		//𔽓]
		//]肪ꍇ
		if(_Dst != 0){
			*_Result -= 1;
			if(sign_s & 0x80){
				*_Mod	= _Dst - _Src;
			} else {
				*_Mod	= _Src - _Dst;
			}
		} else {
			*_Mod = 0;
		}
	} else {
		if(sign_s & 0x80){
			*_Mod	= -_Dst;
		} else {
			*_Mod	=  _Dst;
		}
	}
	_Mod->resize();			//TCY

	return(true);
}
