#pragma once

/****************************************************************/
/*			萔`											*/
/****************************************************************/
//0ŏZɁAOZ荞݁iOj𔭐ꍇA`ĉB
//#define	Zero_Div_Err			

/****************************************************************/
/*			vg^Cv錾									*/
/****************************************************************/
class	BigInt;

//AZuŏꂽ֐
extern "C"{
	void			__fastcall	BigInt_Copy(BigInt* _dst,	BigInt* _src);	//gtRs[
	void			__fastcall	BigInt_Add(	BigInt* _dst,	BigInt* _src);
	void			__fastcall	BigInt_Sub(	BigInt* _dst,	BigInt* _src);
	void			__fastcall	BigInt_Not(	BigInt* _dst,	BigInt* _src);
	void			__fastcall	BigInt_And(	BigInt* _dst,	BigInt* _src);
	void			__fastcall	BigInt_Or(	BigInt* _dst,	BigInt* _src);
	void			__fastcall	BigInt_Xor(	BigInt* _dst,	BigInt* _src);
	void			__fastcall	BigInt_Shl(	BigInt* _src,	unsigned int _Cnt);
	unsigned	int	__fastcall	BigInt_Shr(	BigInt* _src,	unsigned int _Cnt);

	void			__fastcall	BigInt_Shl1(BigInt* _src);	//1bitVtg
	unsigned	int	__fastcall	BigInt_Shr1(BigInt* _src);	//1bitVtg
}


/****************************************************************/
/*			NX`											*/
/****************************************************************/
class BigInt
{
private:
	//--------------
	//o[ϐ
	unsigned	int		m_sz;			//vZp̃TCY
				char*	m_pt;			//obt@̃|C^
	unsigned	int		Buff_Size;		//ۂɊmۂTCY

public:
	//--------------
	//֐
	BigInt(void);									// 0 ŏ
	BigInt(BigInt&	_Src);							//w肳ꂽ{ŏ
	BigInt(int		_Src);							//w肳ꂽlŏ
	BigInt(char* _ptr, unsigned int _sz);			//CӒ̐lŏ
	~BigInt(void);									//

	BigInt&			Set(char* _ptr, unsigned int _sz);	//

private:
	void			Buff_resize();					//Eobt@ŏɊmۂȂB
	void			Buff_resize(unsigned int _sz);	//Eobt@wlɊmۂȂB

public:
	void			resize();						//vZTCYŏɐݒ肷B
	void			resize(unsigned int _sz);		//vZTCYwlɐݒ肷B

	void			Print_Dec();					//10i\Wo͂ɏo
	void			Print_Hex();					//16i\Wo͂ɏo

	char*			Get_Ptr();						//̃|C^擾B
	unsigned int	Get_Byte_Length();				//̃oCg擾
	unsigned long	Get_Bit_Length();				//̃rbg擾
	char			Get_Sign();						//̕擾
	void			Get_Ascii_Dec(string* _asc);	//10i擾

//--------------
//operator Zq
public:
	//
	BigInt&	operator=(BigInt	_Src);	//
	BigInt&	operator=(int		_Src);

	//lZ
	BigInt&	operator+=(BigInt	_Src);	//ZiPj
	BigInt&	operator+=(int		_Src);
	BigInt&	operator++(				);
	BigInt	operator++(int			);	//îԂj
	BigInt	operator+(BigInt&	_Src);	//ZiQj
	BigInt	operator+(int		_Src);

	BigInt&	operator-=(BigInt	_Src);	//ZiPj
	BigInt&	operator-=(int		_Src);
	BigInt&	operator--(				);
	BigInt	operator--(int			);	//îԂj
	BigInt	operator-(BigInt&	_Src);	//ZiQj
	BigInt	operator-(int		_Src);

	BigInt&	operator*=(BigInt&	_Src);	//Z
	BigInt&	operator*=(int		_Src);
	BigInt	operator*(BigInt&	_Src);	//
	BigInt	operator*(int		_Src);

	BigInt&	operator/=(BigInt&	_Src);	//Z
	BigInt&	operator/=(int		_Src);
	BigInt	operator/(BigInt&	_Src);	//
	BigInt	operator/(int		_Src);

	BigInt&	operator%=(BigInt&	_Src);	//Mod
	BigInt&	operator%=(int		_Src);
	BigInt	operator%(BigInt&	_Src);	//
	BigInt	operator%(int		_Src);

	//␔
	BigInt	operator-(void);			//NEG
	BigInt	operator~(void);			//NOT

	//_Z
	BigInt&	operator&=(BigInt&	_Src);	//AND
	BigInt&	operator&=(int		_Src);
	BigInt	operator&(BigInt&	_Src);
	BigInt	operator&(int		_Src);
	BigInt&	operator|=(BigInt&	_Src);	//OR
	BigInt&	operator|=(int		_Src);
	BigInt	operator|(BigInt&	_Src);
	BigInt	operator|(int		_Src);
	BigInt&	operator^=(BigInt&	_Src);	//XOR
	BigInt&	operator^=(int		_Src);
	BigInt	operator^(BigInt&	_Src);
	BigInt	operator^(int		_Src);

	//Vtg
//	BigInt&	operator<<=(BigInt&	_Cnt);
//	BigInt	operator<<(BigInt&	_Cnt);
//	BigInt&	operator>>=(BigInt&	_Cnt);
//	BigInt	operator>>(BigInt&	_Cnt);
	BigInt&	operator<<=(unsigned int	_Cnt);
	BigInt	operator<<( unsigned int	_Cnt);
	BigInt&	operator>>=(unsigned int	_Cnt);
	BigInt	operator>>( unsigned int	_Cnt);

	//r
	bool	operator==(BigInt&	_Src);
	bool	operator==(int		_Src);
	bool	operator!=(BigInt&	_Src);
	bool	operator!=(int		_Src);
	bool	operator<(BigInt&	_Src);
	bool	operator<(int		_Src);
	bool	operator<=(BigInt&	_Src);
	bool	operator<=(int		_Src);
	bool	operator>(BigInt&	_Src);
	bool	operator>(int		_Src);
	bool	operator>=(BigInt&	_Src);
	bool	operator>=(int		_Src);

	bool	Chk_Zero(){
		resize();
		return((m_sz==1) && (m_pt[0] == 0));
	}
	char	Chk_Sign(){
		return(Get_Sign());
	}

	//Math
	BigInt	Power(BigInt&	_Src);	//ݏ
	BigInt	Power(int		_Src);

	//O[oȉZq
	friend	BigInt	operator-(int _Dst, BigInt& _Src);	//Add
	friend	BigInt	operator+(int _Dst, BigInt& _Src);	//Sub
	friend	BigInt	operator*(int _Dst, BigInt& _Src);	//Mul
	friend	BigInt	operator/(int _Dst, BigInt& _Src);	//Div
	friend	BigInt	operator%(int _Dst, BigInt& _Src);	//Mod
	friend	BigInt	operator&(int _Dst, BigInt& _Src);	//And
	friend	BigInt	operator|(int _Dst, BigInt& _Src);	//Or
	friend	BigInt	operator^(int _Dst, BigInt& _Src);	//Xor
//	friend	BigInt	operator<<(int _Dst, BigInt& _Cnt);	//Shl
//	friend	BigInt	operator>>(int _Dst, BigInt& _Cnt);	//Shr
	friend	bool	operator==(int _Dst, BigInt& _Src);	//
	friend	bool	operator!=(int _Dst, BigInt& _Src);	//
	friend	bool	operator<( int _Dst, BigInt& _Src);	//
	friend	bool	operator<=(int _Dst, BigInt& _Src);	//
	friend	bool	operator>( int _Dst, BigInt& _Src);	//
	friend	bool	operator>=(int _Dst, BigInt& _Src);	//

	friend	void	BigInt_Mul_FFT(	BigInt* _Dst,	BigInt _Src1, BigInt _Src2);
	friend	void	BigInt_Mul(		BigInt* _Dst,	BigInt _Src1, BigInt _Src2);
	friend	void	BigInt_Mul(		BigInt* _Dst,	BigInt _Src1, int _Src2);
	friend	bool	BigInt_Div(		BigInt* _Result,BigInt* _Mod, BigInt _Dst, BigInt _Src);
	friend	bool	BigInt_Power(	BigInt* _Result,BigInt& _Dst, BigInt& _Src);
	friend	bool	BigInt_Power(	BigInt* _Result,BigInt  _Dst, int _Src);
};
