#pragma once

//======================================================================
//		Simontgomery reductionj
//----------------------------------------------------------------------
//  Reference:
//		http://ja.wikipedia.org/wiki/%E3%83%A2%E3%83%B3%E3%82%B4%E3%83%A1%E3%83%AA%E4%B9%97%E7%AE%97
//======================================================================
//
//		ZIɍsƂȂA]߂ASYłB
//		Z̓S\ŌvZAvZIiKŋtϊ΁A]肪܂B
//
//		yMontgomery ReductioniS_NVjz
//		MR( T )	 T ~ R-1 mod N
//				 (T { (T ~ N' mod R) ~ N)  R
//
//		R2̙pɂ̂ŁAȐZ̓rbgVtgAR̗]͘_ςŋ܂B
//
//		yS\ւ̕ϊƋtϊz
//		A  MR( a ~ R2 )		c@S\ւ̕ϊ
//		a  MR( A )			c	tϊ
//		R2 = R ~ R mod N
//
//		yS\ł̌vZz
//		sZt
//		C  A { B
//		if (c  0) then C  C { N
//		if (C  N) then C  C | N
//		
//		sZt
//		C  MR( A ~ B )			c R|̂ŁAS_NViR-1|jB
//
//		AAPɁAc = a ~ b mod N߂ɓẮA
//		c = MR( MR(a ~ b) ~ R2 )		̕I
//
//		
//						Copyright (c) A.Watanabe (2012)
//
//----------------------------------------------------------------------
//	Revision
//		2012. 7. 	
//======================================================================
/****************************************************************/
/*			萔`											*/
/****************************************************************/


/****************************************************************/
/*			vg^Cv錾									*/
/****************************************************************/


/****************************************************************/
/*			NX`											*/
/****************************************************************/
class montgomery
{
private:
				BigInt	m_N;		//@
				BigInt	m_invN;		//
				BigInt	m_R2;		//R2
				BigInt	m_R_1;		//R-1
	unsigned	int		m_m;		//

public:
	//--------------
	//֐
	montgomery(void);								//
	~montgomery(void);								//

	void	Set_Modulo(BigInt* N);					//Set Modulo
	void	MR(BigInt* result, BigInt T);			//Montgomery reduction

	void	Mul(	BigInt* dst,	 BigInt& src1, BigInt& src2);
	void	Power(	BigInt* _Result, BigInt& _Src1, BigInt& _Src2);
};
